/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// pile réalisée avec un tableau (capacité bornée)
// (voir vector.h pour une implémentation sans limite sur la capacité)

#include "prelude.h"

#ifndef ASTACK
#define ASTACK

typedef struct ArrStack astack;

astack *astack_create(int cap);
bool astack_is_empty(astack *s);
void astack_push(astack *s, int x);
int astack_top(astack *s);
int astack_pop(astack *s);
void astack_delete(astack *s);

#endif
