
(* Plus court chemin dans un graphe orienté pondéré par l'algorithme A* *)

val astar: Wdigraph.wdigraph -> int -> int -> (int -> float) -> float
  (* [astar g src dst h] renvoie la longueur d'un plus court chemin de
     `src` à `dst`, en utilisant l'heuristique `h`. Lève `Not_found` s'il
     n'y a pas de chemin. *)

val astar_path: Wdigraph.wdigraph -> int -> int -> (int -> float)
  -> float * int list
  (* renvoie également un chemin de longueur minimal *)


val astar_count: Wdigraph.wdigraph -> int -> int -> (int -> float)
  -> int * float
  (* renvoie le nombre de sommets mis dans la file (pour faire des
     expériences) *)
