/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Tableau de bits
// (8 fois plus compact qu'un tableau de type bool[])

#include "prelude.h"

#ifndef BITARRAY
#define BITARRAY

typedef struct Bitarray bitarray;

bitarray *bitarray_create(int size, bool b);
// tous les éléments à b

int bitarray_size(bitarray *a);

void bitarray_set(bitarray *a, int i, bool b);

bool bitarray_get(bitarray *a, int i);

void bitarray_delete(bitarray *a);

#endif
