
(* Formes normales conjonctives

   Un littéral `x` est un entier dans 1..n (variable x)
   ou dans -n..-1 (négation de la variable -x).

   Une clause `c` est une liste de littéraux, sans doublons,
   triée par ordre croissant de valeur absolue. *)

type literal = int
type clause = literal list
type kind = CNF | DNF
type nf = { kind: kind; nbvars: int; clauses: clause list }

val dimacs: Format.formatter -> nf -> unit

val cnf: Fmla.fmla -> nf
