
(* Compression de texte avec l'algorithme de Huffman *)

type tree

type compressed = string
(* Ici, le texte compressé est une chaîne de caractères '0' et '1'.
   Dans une implémentation réaliste, ce serait des bits. *)

val encode: string -> tree * compressed
val decode: tree * compressed -> string

val encode_full: string -> compressed
val decode_full: compressed -> string

val print_tree: Format.formatter -> tree -> unit
val print_ocaml_tree: Format.formatter -> tree -> unit
