
(* une pile mutable, polymorphe

   notes :
   - existe déjà dans la bibliothèque standard OCaml (Stack)
   - Vector offre une autre implémentation, plus compacte
*)

type 'a stack

val create: unit -> 'a stack
val is_empty: 'a stack -> bool
val push: 'a stack -> 'a -> unit
val top: 'a stack -> 'a
val pop: 'a stack -> 'a

