/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#ifndef MATH
#define MATH

int math_power(int x, int n);
int math_power_naive(int x, int n);

uint64_t math_power_mod(uint64_t x, int n, uint64_t m);

typedef struct Euclidean { int quotient, remainder; } euclidean;

euclidean math_division(int a, int b);

#endif
