/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Tri

#include "prelude.h"

#ifndef SORT
#define SORT

void knuth_shuffle(int a[], int n);
  // mélange le tableau a

bool is_sorted(int a[], int n);
  // vérifie que a est trié dans l'ordre croissant

// toutes les fonctions de tri ci-dessous trient dans l'ordre croissant

void two_way_sort(int a[], int n);
  // pour un tableau ne contenant que les valeurs 0 et 1

void dutch_flag(int a[], int n);
  // pour un tableau ne contenant que les valeurs 0, 1, 2

void insertion_sort(int a[], int n);

void binary_sort(int a[], int n);

void selection_sort(int a[], int n);

void heapsort_(int a[], int n);

void quicksort(int a[], int n);

void mergesort_(int a[], int n);

void bottom_up_mergesort(int a[], int n);

void natural_mergesort(int a[], int n);

#endif
