/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// file réalisée avec deux piles

#include "prelude.h"

#ifndef AQUEUE
#define AQUEUE

typedef struct AQueue aqueue;

aqueue *aqueue_create(void);
int aqueue_size(aqueue *q);
bool aqueue_is_empty(aqueue *q);
void aqueue_enqueue(aqueue *q, int x);
int aqueue_peek(aqueue *q);
int aqueue_dequeue(aqueue *q);
void aqueue_delete(aqueue *q);

#endif
