/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// tableau (contenant des entiers)
// avec longueur et accès défensif aux cases avec assert

#include "prelude.h"

#ifndef ARRAY
#define ARRAY

typedef struct Array array;

array *array_create(int n, int x);
int array_size(array *a);
int array_get(array *a, int i);
void array_set(array *a, int i, int x);
void array_delete(array *a);

#endif
