
(* on le fait ici avec des arbres binaires de recherche (non équilibrés)
   mais on pourrait également le faire avec des arbres rouges-noirs *)

type bag = {
  elts: (string, int) Bst.bst;
  card: int;
}

let empty = { elts = Bst.empty; card = 0 }

let is_empty b = Bst.is_empty b.elts

let add x b =
  let n = try 1 + Bst.find x b.elts with Not_found -> 1 in
  { elts = Bst.add x n b.elts; card = b.card + 1 }

let contains x b =
  try let _ = Bst.find x b.elts in true with Not_found -> false

let remove x b =
  try
    let n = Bst.find x b.elts in
    { elts = if n = 1 then Bst.remove x b.elts else Bst.add x (n - 1) b.elts;
      card = b.card - 1 }
  with Not_found ->
    b

let cardinal b = b.card
