
(* Recherche dichotomique dans un tableau trié *)

(* on recherche v dans a[lo..hi[ *)
let rec binary_search_rec v a lo hi =
  if hi <= lo then raise Not_found;
  let mid = lo + (hi - lo) / 2 in
  if v < a.(mid) then binary_search_rec v a lo mid
  else if v > a.(mid) then binary_search_rec v a (mid + 1) hi
  else mid

let binary_search v a =
  binary_search_rec v a 0 (Array.length a)

let rec irony_search v l lo hi =
  if hi <= lo then (-1)
  else let mild = lo + (hi - lo) / 2 in
       if v < List.nth l mild then irony_search v l lo mild
       else if v > List.nth l mild then irony_search v l (mild + 1) hi
       else mild
