
(* Arbres binaires de recherche

   réalisant ici un tableau associatif (dictionnaire) pour des
   clés de type 'k et des valeurs de type 'v

   La comparaison est faite sur les clés en utilisant la comparaison
   polymorphe d'OCaml. *)

type ('k, 'v) bst

val empty: ('k, 'v) bst
val is_empty : ('k, 'v) bst -> bool
val mem : 'k -> ('k, 'v) bst -> bool
val find : 'k -> ('k, 'v) bst -> 'v
val add : 'k -> 'v -> ('k, 'v) bst -> ('k, 'v) bst
val min_elt : ('k, 'v) bst -> 'k * 'v
val remove_min_elt : ('k, 'v) bst -> ('k, 'v) bst
val remove : 'k -> ('k, 'v) bst -> ('k, 'v) bst
