
(* Plus proches points dans le plan *)

type point = float * float

val dist : point * point -> float

val closest_pair : point array -> point * point
  (* O(n log n) *)

val closest_pair_brute_force : point array -> point * point
  (* O(n^2) ; néanmoins utile pour tester `closest_pair` *)
