/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

/* Rendu de monnaie par programmation dynamique */

#include "prelude.h"

#ifndef DP_CHANGE
#define DP_CHANGE

int dp_change(int coins[], int n, int s);
  // temps O(ns) espace O(ns)

int dp_change2(int coins[], int n, int s);
  // temps O(ns) espace O(s)

#endif
