(* Supposons avoir une fonction d'interprétation (c'est possible)... *)
let eval (s: string) (e: string): string =
  failwith "not implemented"

(* ... et une fonction de test d'équivalence sémantique (impossible)... *)
let equiv (s: string) (t: string): bool =
  failwith "not implemented"

(* ... on en déduit un test de trivialité et une résolution du problème
   de l'arrêt. *)
let trivial (s: string): bool =
  equiv s "fun _ -> true"

let halts (s: string) (e: string): bool =
  trivial "fun _ -> try let _ = eval s e in true
                    with _ -> true"

(* Voici une déclaration de la fonction dont le code source est donné
   ci-dessus. *)
let f (s: string) (e: string): string -> bool =
  fun _ -> try let _ = eval s e in true
           with _ -> true
