
(* Arbres k-dimensionnels *)

type point = float array

type 'a kdtree

val of_array: (point * 'a) array -> 'a kdtree
  (* construit un arbre k-dimensionnel à partir d'un tableau de données *)

val closest:  int -> point -> 'a kdtree -> (point * 'a) array
  (* `closest_naive k p0 t` renvoie les `k` points les plus proches de `p0`
     dans l'arbre `t` *)
