/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// matrice (contenant des entiers)

#include "prelude.h"

#ifndef MATRIX
#define MATRIX

typedef struct Matrix matrix;

matrix *matrix_create(int r, int c, int x);
int matrix_rows(matrix *m);
int matrix_cols(matrix *m);
int matrix_get(matrix *m, int i, int j);
void matrix_set(matrix *m, int i, int j, int x);
void matrix_print(matrix *m);
void matrix_delete(matrix *m);

#endif
