
type 'a stack = 'a list ref

let create () =
  ref []

let is_empty st =
  !st = []

let push st x =
  st := x :: !st

let top st = match !st with
  | [] -> invalid_arg "top"
  | x :: _ -> x

let pop st = match !st with
  | [] -> invalid_arg "pop"
  | x :: l -> st := l; x
