
(* Arbres

   (pour les arbres binaires, voir Bintree) *)

type 'a tree =
  | N of 'a * 'a tree list

val preorder: ('a -> unit) -> 'a tree -> unit
val postorder: ('a -> unit) -> 'a tree -> unit

val traverse: ('a -> unit) -> ('a -> unit) -> 'a tree -> unit

val size: 'a tree -> int

val mirror: 'a tree -> 'a tree
