/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// file réalisée avec un tableau redimensionnable (circulaire)
// (exercice)

#include "prelude.h"

#ifndef VQUEUE
#define VQUEUE

typedef struct VQueue vqueue;

vqueue *vqueue_create(int capacity);
  // on donne une capacité initiale mais le tableau interne est redimensionné
  // lorsque c'est nécessaire
int vqueue_size(vqueue *q);
bool vqueue_is_empty(vqueue *q);
void vqueue_enqueue(vqueue *q, int x);
int vqueue_peek(vqueue *q);
int vqueue_dequeue(vqueue *q);
void vqueue_delete(vqueue *q);

#endif
