
(* graphe orienté pondéré

  les sommets sont les entiers 0,1,...,size-1
  les poids sont des flottants
*)

type wdigraph

val create: int -> wdigraph

val size: wdigraph -> int

val has_edge: wdigraph -> int -> int -> bool

val weight: wdigraph -> int -> int -> float

type edge = float * int * int

val add_edge: wdigraph -> edge -> unit

val succ: wdigraph -> int -> (int * float) list

val edges: wdigraph -> edge list

val load: string -> wdigraph

val print: Format.formatter -> wdigraph -> unit

