
(* graphe non orienté pondéré

  les sommets sont les entiers 0,1,...,size-1
  les poids sont des flottants
*)

type wgraph

val create: int -> wgraph

val size: wgraph -> int

val has_edge: wgraph -> int -> int -> bool

val weight: wgraph -> int -> int -> float

type edge = float * int * int

val add_edge: wgraph -> edge -> unit

val succ: wgraph -> int -> (int * float) list

val edges: wgraph -> edge list

val load: string -> wgraph

val print: Format.formatter -> wgraph -> unit

val wdigraph: wgraph -> Wdigraph.wdigraph

